package com.franckbarbier.jdbc_oracle;

// import java.io.*;
public final class JDBC_Oracle {

    private /*final*/ String _user = "barbier";
    private /*final*/ String _password = "barbier";
    private final java.sql.Connection _connection;

    public JDBC_Oracle() throws java.sql.SQLException {
        System.out.println("Please enter information for connecting to Oracle...");
        _user = readEntry("User: ");
        int slash_index = _user.indexOf('/');
        if (slash_index != -1) {
            _password = _user.substring(slash_index + 1);
            _user = _user.substring(0, slash_index);
        } else {
            _password = readEntry("Password: ");
        }
        java.sql.DriverManager.registerDriver(new oracle.jdbc.OracleDriver());
        _connection = java.sql.DriverManager.getConnection("jdbc:oracle:thin:@scinfe098.univ-pau.fr:1521:etud", _user, _password);
        java.sql.Statement statement = _connection.createStatement();
        statement.execute("DROP TABLE Individual"); // Clean up prior execution...
        statement.execute("CREATE TABLE Individual(\n" // For test only...
                + "individual_id INTEGER,\n"
                + "given_name VARCHAR(30),\n"
                + "surname VARCHAR(30),\n"
                + "CONSTRAINT Individual_key PRIMARY KEY(individual_id))");
// Administrative API (metadata) specific to Oracle RDBMS:
        String query = "SELECT * FROM all_objects WHERE owner='" + _user.toUpperCase() + "'";
        java.sql.ResultSet result_set = statement.executeQuery(query);
        java.sql.ResultSetMetaData metadata = result_set.getMetaData();
        while (result_set.next()) {
            for (int i = 1; i <= metadata.getColumnCount(); i++) {
                System.out.print(result_set.getString(i) + "(Searchable: " + metadata.isSearchable(i) + ") ");
            }
            System.out.println();
        }
        // result_set.close();
        // statement.close(); // => 'result_set.close();'
        _connection.close(); // => 'statement.close();'
    }

    public void close() {
        try {
            if (_connection != null) {
                _connection.close();
            }
        } catch (java.sql.SQLException sqle) {
            throw new RuntimeException(sqle);
        }
    }

    // Utility function to read a line from standard input stream:
    static String readEntry(String prompt) {
        try {
            StringBuilder buffer = new StringBuilder(); // 'StringBuilder' is faster than 'StringBuffer buffer = new StringBuffer();'...
            System.out.println(prompt);
            System.out.flush();
            int c = System.in.read();
            while (c != '\n' && c != -1) {
                buffer.append((char) c);
                c = System.in.read();
            }
            return buffer.toString().trim();
        } catch (java.io.IOException ioe) {
            System.err.println("Fatal I/O error... " + ioe.getMessage());
            return "";
        }
    }

    public static void main(String[] args) {
        JDBC_Oracle test = null;
        try {
            test = new JDBC_Oracle();
        } catch (java.sql.SQLException sqle) {
            sqle.printStackTrace();
            if (test != null) {
                test.close();
            }
        }
    }
}
